'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * A React component for the font-awesome icon library.
 *
 * @param {String} [ariaLabel] An extra accessibility label to put on the icon
 * @param {Boolean} [border=false] Whether or not to show a border radius
 * @param {String} [className] An extra set of CSS classes to add to the component
 * @param {Object} [cssModule] Option to pass FontAwesome CSS as a module
 * @module FontAwesome
 * @type {ReactClass}
 */
var FocusElement = function (_Component) {
  _inherits(FocusElement, _Component);

  function FocusElement(props) {
    _classCallCheck(this, FocusElement);

    return _possibleConstructorReturn(this, (FocusElement.__proto__ || Object.getPrototypeOf(FocusElement)).call(this, props));
  }

  _createClass(FocusElement, [{
    key: 'handle',
    value: function handle(event) {
      var userSelection = void 0;
      if (window.getSelection) {
        userSelection = window.getSelection();
      } else if (document.selection) {
        userSelection = document.selection.createRange();
      };
      var content = event.target.firstChild;
      if (content) {
        var range = document.createRange();
        range.selectNode(content);
        range.setStart(content, content.length);
        range.setEnd(content, content.length);
        userSelection.removeAllRanges();
        userSelection.addRange(range);
        userSelection.extend(content, content.length);
        userSelection.collapseToEnd();
      } else {
        event.target.focus();
      };
    }
  }, {
    key: 'render',
    value: function render() {
      var self = this;
      setTimeout(function () {
        self.refs.focus.setAttribute("contenteditable", 'plaintext-only');
      }, 0);
      return _react2.default.createElement('div', _extends({}, this.props, { ref: 'focus', onClick: this.handle.bind(this) }));
    }
  }]);

  return FocusElement;
}(_react.Component);

// FocusElement.propTypes = {
//   ariaLabel: PropTypes.string,
//   border: PropTypes.bool,
//   className: PropTypes.string,
//   cssModule: PropTypes.object,
//   fixedWidth: PropTypes.bool,
//   flip: PropTypes.oneOf([ 'horizontal', 'vertical' ]),
//   inverse: PropTypes.bool,
//   name: PropTypes.string.isRequired,
//   pulse: PropTypes.bool,
//   rotate: PropTypes.oneOf([ 90, 180, 270 ]),
//   size: PropTypes.oneOf([ 'lg', '2x', '3x', '4x', '5x' ]),
//   spin: PropTypes.bool,
//   stack: PropTypes.oneOf([ '1x', '2x' ]),
//   tag: PropTypes.string,
// }

exports.default = FocusElement;